#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <signal.h>

#define BACKLOG 10
#define PORT_DEF 2010
#define BUF_SIZE 256

void sigchld_handler(int a){
	while (wait(NULL) > 0);
}

int main(int argc, char* argv[]){
	int port;
	if (argc == 1){
		port = PORT_DEF;	
	}else if(argc == 2){
		port = atoi(argv[1]);
	}
	else exit(1);
	int sock_desc, new_sock;
	struct sockaddr_in my_addr;
	struct sockaddr_in client;
	int yes = 1;
	int sin_size;
	if ((sock_desc = socket(AF_INET, SOCK_STREAM,0)) == -1){
    	perror("socket");
    	exit(1);
	}
	if (setsockopt(sock_desc, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1){
		perror("setsockopt");
		exit(1);
	}
	my_addr.sin_family = AF_INET;
	my_addr.sin_port = htons(port);
	my_addr.sin_addr.s_addr = INADDR_ANY;
	memset(&(my_addr.sin_zero), '\0', 8);
	if (bind(sock_desc, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1){
		perror("bind");
		exit(1);
	}
	if(listen(sock_desc, BACKLOG) == -1){
		perror("listen");
		exit(1);
	}
	struct sigaction sa;
	sa.sa_handler = sigchld_handler;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	if (sigaction(SIGCHLD, &sa, NULL) == -1){
		perror("sigaction");
		exit(1);
	}
	while(1){
		sin_size = sizeof(struct sockaddr_in);
		if((new_sock = accept(sock_desc, (struct sockaddr *)&client, &sin_size)) == -1){
			perror("accept");
			continue;
		}
		printf("Zostalo nawiazane polaczenie z %s.\n", inet_ntoa(client.sin_addr));
		if (!fork()){
			close(sock_desc);
			char buf[BUF_SIZE];
			int a, b, i;
			recv(new_sock, &a, sizeof(int), 0); 
			recv(new_sock, &b, sizeof(int), 0);
			i=b;
			if (a>b) {
				while(i<=a){
					send(new_sock, &i, sizeof(int), 0);
					i++;
				}
			}else{
				while(i>=a){
					send(new_sock, &i, sizeof(int), 0);	
					i--;
				}
			}
			a = 777777;
			send(new_sock, &a, sizeof(int), 0);
			close(new_sock);
			exit(0);
		}
		close(new_sock);
	}
	close(sock_desc);
	return 0;
}
